# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.one_time_address import OneTimeAddress
from fireblocks.models.transfer_peer_path_sub_type import TransferPeerPathSubType
from fireblocks.models.transfer_peer_path_type import TransferPeerPathType
from typing import Optional, Set
from typing_extensions import Self

class DestinationTransferPeerPath(BaseModel):
    """
    The destination of the transaction.
    """ # noqa: E501
    type: TransferPeerPathType
    sub_type: Optional[TransferPeerPathSubType] = Field(default=None, alias="subType")
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    wallet_id: Optional[StrictStr] = Field(default=None, alias="walletId")
    one_time_address: Optional[OneTimeAddress] = Field(default=None, alias="oneTimeAddress")
    __properties: ClassVar[List[str]] = ["type", "subType", "id", "name", "walletId", "oneTimeAddress"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DestinationTransferPeerPath from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of one_time_address
        if self.one_time_address:
            _dict['oneTimeAddress'] = self.one_time_address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DestinationTransferPeerPath from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "subType": obj.get("subType"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "walletId": obj.get("walletId"),
            "oneTimeAddress": OneTimeAddress.from_dict(obj["oneTimeAddress"]) if obj.get("oneTimeAddress") is not None else None
        })
        return _obj


