# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ScreeningProviderRulesConfigurationResponse(BaseModel):
    """
    ScreeningProviderRulesConfigurationResponse
    """ # noqa: E501
    direction: Optional[StrictStr] = None
    status: Optional[StrictStr] = None
    amount_usd: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="amountUSD")
    amount: Optional[Union[StrictFloat, StrictInt]] = None
    asset: Optional[StrictStr] = None
    action: StrictStr
    __properties: ClassVar[List[str]] = ["direction", "status", "amountUSD", "amount", "asset", "action"]

    @field_validator('direction')
    def direction_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['INBOUND', 'OUTBOUND']):
            raise ValueError("must be one of enum values ('INBOUND', 'OUTBOUND')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['COMPLETED', 'PENDING', 'REJECTED', 'FAILED', 'CANCELED', 'BLOCKING_TIME_EXPIRED']):
            raise ValueError("must be one of enum values ('COMPLETED', 'PENDING', 'REJECTED', 'FAILED', 'CANCELED', 'BLOCKING_TIME_EXPIRED')")
        return value

    @field_validator('action')
    def action_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['ACCEPT', 'REJECT', 'ALERT', 'WAIT', 'FREEZE', 'CANCEL']):
            raise ValueError("must be one of enum values ('ACCEPT', 'REJECT', 'ALERT', 'WAIT', 'FREEZE', 'CANCEL')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScreeningProviderRulesConfigurationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScreeningProviderRulesConfigurationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "direction": obj.get("direction"),
            "status": obj.get("status"),
            "amountUSD": obj.get("amountUSD"),
            "amount": obj.get("amount"),
            "asset": obj.get("asset"),
            "action": obj.get("action")
        })
        return _obj


